//---- KontenVerwaltung, Beispiel fr Polymorphie ---------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop
#include "KontenVerw_u1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#include "Kl_Konto_all.cpp"
Konto *dasKonto[30];            // Instanzvariablen vereinbaren
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner): TForm(Owner)
{
int i;
for(i=1; i<=9; i++)
      dasKonto[i]= new Festgeldkonto(5000,360,10);

  for(i=10; i<=19; i++)
      dasKonto[i]= new GiroKonto(100000);


  for(i=20; i<=29; i++)
      dasKonto[i]=  new SparKonto(100);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::edtKontoNrChange(TObject *Sender)
{
int kontoNr;

edtStandNeu->Clear();
edtStandAlt->Clear();
  if (edtKontoNr->Text != ""  &&  edtKontoNr->Text != " ")
      {
      kontoNr= StrToInt(edtKontoNr->Text);
      if (kontoNr >= 1  &&  kontoNr <= 29)
          {
          edtStandNeu->Text = FormatFloat("0.00", dasKonto[kontoNr]->getKontostand() /100.0);
          edtKontoArt->Text = dasKonto[kontoNr]->getKontoArt();
          if (kontoNr >= 1  &&  kontoNr <= 9)
                {
                edtRestlaufzeit->Text = dasKonto[kontoNr]->gibRestlaufzeit();
                if (dasKonto[kontoNr]-> gibRestlaufzeit() > 0)
                        Shape1->Brush->Color = clRed;
                else
                        Shape1->Brush->Color = clGreen;
                }
          else
             {
             edtRestlaufzeit->Text = "unzulssig";
             Shape1->Brush->Color = clGray;
             }
          }
      else
          {
          edtKontoArt->Text= "unzulssig";
          edtRestlaufzeit->Text = "unzulssig";
          }
	  }	  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnAusfuehrenClick(TObject *Sender)
{
int kontoNr,
    betrag;    // in Cent

  kontoNr= StrToInt(edtKontoNr->Text);
  if (kontoNr >= 1  &&  kontoNr <= 29)
      {
      edtStandAlt->Text =
          FormatFloat("0.00", dasKonto[kontoNr]->getKontostand() / 100.0);
      betrag= floor( StrToFloat(edtBetragEuro->Text) * 100 );
      dasKonto[kontoNr]->buchen(betrag);
      edtStandNeu->Text =
          FormatFloat("0.00", dasKonto[kontoNr]->getKontostand() /100.0);
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
int kontoNr;
if (edtKontoNr->Text != ""  &&  edtKontoNr->Text != " ")
   {
   kontoNr = StrToInt(edtKontoNr->Text);
   if (kontoNr >= 1  &&  kontoNr <= 9)
        {
        dasKonto[kontoNr]->vermindereLaufzeit( );
        btnGibRestlaufzeitClick(this);
        }
   }
else
   edtRestlaufzeit->Text = "unzulssig";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGibRestlaufzeitClick(TObject *Sender)
{
int kontoNr;
if (edtKontoNr->Text != ""  &&  edtKontoNr->Text != " ")
   {
   kontoNr = StrToInt(edtKontoNr->Text);
   if (kontoNr >= 1  &&  kontoNr <= 9)
        {
        edtRestlaufzeit->Text = dasKonto[kontoNr]->gibRestlaufzeit();
        if (dasKonto[kontoNr]-> gibRestlaufzeit() <= 0)
                        Shape1->Brush->Color = clGreen;
        }
   }
else
   edtRestlaufzeit->Text = "unzulssig";
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()        // Destruktor der Klasse TForm1
{
int i;
  for (i=0; i<=29; i++)
     delete dasKonto[i];
}
